Subject: Re: bug#67360: 29.1; MH-E forwarded email has a mangled default Subject header

From: Eli Zaretskii <[email-masked]>
Date: Wed, 22 Nov 2023 16:42:30 +0200

> Cc: [email-masked]
> From: Chris Siebenmann <[email-masked]>
> Date: Tue, 21 Nov 2023 19:49:24 -0500
> 
> If you attempt to forward an email message in MH-E with mh-forward
> (bound to eg 'f'), then the resulting Subject: of the draft message will
> be manged and come out as, for example:
> 
> 	Subject: test forwarding subject (fwd) Chris Siebenmann: test forwarding subject
> 
> The original subject of the test message was 'test forwarding subject'.
> The 'test forwarding subject (forw)' portion of the mh-forward Subject
> comes from the default Ubuntu 22.04 NMH 1.7.1 /etc/nmh/forwcomps file,
> used by 'forw' to create the NMH draft, which has:
> 
> 	Subject:%<{nmh-subject} %(trim)%(putlit)%?{subject} %(trim)%(putlit) (fwd)%>
> 
> The portion after it comes from the fact that mh-forward creates its own
> new Subject: for the forwarded message (using
> mh-forwarded-letter-subject, which in turn formats with
> mh-forward-subject-format), and then does:
> 
> 	(mh-insert-fields "Subject:" forw-subject)
> 
> I suspect that the intention is to replace any existing Subject:, or
> perhaps mh-forward assumes that the draft won't have one. Unfortunately
> for mh-forward, mh-insert-fields is specifically documented to *append*
> to the existing header field value, if there is one, not overwrite it,
> so the resulting Subject: of the draft is as we see here: the original
> subject created by 'forw', and then an appended Subject from mh-forward.
> This result is not terribly useful.
> 
> Reproduction in emacs -Q provided you have NMH and MH-E set up:
> * enter MH-E with 'M-x mh-rmail'
> * arrange to have some message in your inbox that you can forward, for
>   example by 'F r' to see all of your inbox.
> * display your test message to forward, eg cursor to it and hit Return
> * start to forward with 'f' or 'M-x mh-forward'.
> 
> NOTE: while I have reproduced this in a clean Emacs (and NMH)
> environment with 'emacs -Q', this report is being filed from within my
> regular customized Emacs because life is too short. You can skip over
> the packages, shadowed load files, and so on.

Adding Bill.

I'm not sure if it is better to report MH-E-related bugs here or
submit the reports to https://sourceforge.net/p/mh-e/bugs/.